Subject: Re: [PATCH] netem: add cell concept to simulate special MAC behavior

From: Stephen Hemminger <[email-masked]>
Date: Mon, 12 Dec 2011 09:19:57 -0800

On Sun, 11 Dec 2011 01:11:54 +0100
Hagen Paul Pfeifer <[email-masked]> wrote:

> This extension can be used to simulate special link layer
> characteristics. Simulate because packet data is not modified, only the
> calculation base is changed to delay a packet based on the original
> packet size and artificial cell information.
> 
> packet_overhead can be used to simulate a link layer header compression
> scheme (e.g. set packet_overhead to -20) or with a positive
> packet_overhead value an additional MAC header can be simulated. It is
> also possible to "replace" the 14 byte Ethernet header with something
> else.
> 
> cell_size and cell_overhead can be used to simulate link layer schemes,
> based on cells, like some TDMA schemes. Another application area are MAC
> schemes using a link layer fragmentation with a (small) header each.
> Cell size is the maximum amount of data bytes within one cell. Cell
> overhead is an additional variable to change the per-cell-overhead
> (e.g.  5 byte header per fragment).
> 
> Example (5 kbit/s, 20 byte per packet overhead, cell-size 100 byte, per
> cell overhead 5 byte):
> 
>   tc qdisc add dev eth0 root netem rate 5kbit 20 100 5
> 
> Signed-off-by: Hagen Paul Pfeifer <[email-masked]>
> Signed-off-by: Florian Westphal <[email-masked]>

Acked-by: Stephen Hemminger <[email-masked]>